/**
*	Metamaxim ModelScope
*	Copyright 2003 Metamaxim Ltd
*/
package ABC1;

import com.metamaxim.modelscope.callbacks.*;

public class Order extends Behaviour {


	private int getPrice() {
	// Works out which price to use for an Order based on its state
		if (this.getState("Order").equals("Open"))
			return(this.getInstance("Product").getCurrency("Unit Price"));
		else if (this.getState("Order").equals("Cancelled")) return 0;
		else return (this.getCurrency("Frozen Price"));
	}


	public int getOrderTotal() {
	// Calculates the total value of an Order
		return (this.getInteger("Quantity") * this.getPrice() * this.getInstance("Product").getInteger("VAT Rate")) / 100;
	}


	public String getStatus() {
	// Shows the state of the Order
		return this.getState("Order");
	}

	public void processConfirm(Event event, String subscript) {
	// Freezes the price to be used for the Order, so that subsequent changes to the Product Price
	// do not affect it
		int frozenprice = this.getInstance("Product").getCurrency("Unit Price");
		this.setCurrency("Frozen Price", frozenprice);
	}

}
